"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Renderer = void 0;
/* eslint-disable @typescript-eslint/no-unused-vars */
const lit_html_1 = require("@rxdi/lit-html");
function Render(config) {
    return function (cls) {
        if (!window.customElements.get(config.selector)) {
            return (0, lit_html_1.Component)(config)(cls);
        }
    };
}
/**
 * @customElement r-renderer
 */
let Renderer = class Renderer extends lit_html_1.LitElement {
    constructor() {
        super(...arguments);
        this.options = {
            state: {},
            render: (res, setState, shadowRoot) => (0, lit_html_1.html) ` ${res} `,
            style: (0, lit_html_1.css) ``,
            deepCloneState: false,
            loading: () => (0, lit_html_1.html) ``,
            error: (e) => (0, lit_html_1.html) ``,
        };
        this.loading = true;
        this.error = '';
        this.state = {};
    }
    OnUpdateFirst() {
        return __awaiter(this, void 0, void 0, function* () {
            this.options.state = yield this.options.state;
            if (this.options.state) {
                if (this.isObservable(this.options.state)) {
                    this.subscription = this.options.state['subscribe']((detail) => {
                        this.state = detail;
                        this.loading = false;
                        this.dispatchEvent(new CustomEvent('onData', { detail }));
                    }, (error) => {
                        this.state = null;
                        this.error = error;
                        this.loading = false;
                        this.dispatchEvent(new CustomEvent('onError', { detail: error }));
                    });
                }
                else {
                    this.loading = false;
                    this.state = this.options.state;
                }
            }
        });
    }
    isObservable(value) {
        return this.isFunction(value.lift) && this.isFunction(value.subscribe);
    }
    isFunction(value) {
        return typeof value === 'function';
    }
    OnDestroy() {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
    renderContent() {
        if (!this.error && this.options.render) {
            const template = this.options.render(this.options.deepCloneState
                ? JSON.parse(JSON.stringify(this.state))
                : this.state, (state) => (this.state = Object.assign({}, state)), this.shadowRoot);
            if (template === null || template === void 0 ? void 0 : template.strings) {
                return template;
            }
            return (0, lit_html_1.html) ``;
        }
        return this.state;
    }
};
exports.Renderer = Renderer;
__decorate([
    (0, lit_html_1.property)({ type: Object }),
    __metadata("design:type", Object)
], Renderer.prototype, "options", void 0);
__decorate([
    (0, lit_html_1.property)({ type: Boolean }),
    __metadata("design:type", Object)
], Renderer.prototype, "loading", void 0);
__decorate([
    (0, lit_html_1.property)({ type: String }),
    __metadata("design:type", Object)
], Renderer.prototype, "error", void 0);
__decorate([
    (0, lit_html_1.property)(),
    __metadata("design:type", Object)
], Renderer.prototype, "state", void 0);
exports.Renderer = Renderer = __decorate([
    Render({
        selector: 'r-renderer',
        template() {
            var _a;
            return (0, lit_html_1.html) `
      ${((_a = this.options) === null || _a === void 0 ? void 0 : _a.style)
                ? (0, lit_html_1.html) `
            <style>
              ${this.options.style}
            </style>
          `
                : (0, lit_html_1.html) ``}
      ${!this.loading ? this.renderContent() : ''}
      ${this.loading
                ? (0, lit_html_1.html) `
            ${this.isFunction(this.options.loading)
                    ? this.options.loading()
                    : (0, lit_html_1.html) ``}
          `
                : ''}
      ${this.error
                ? (0, lit_html_1.html) `
            ${this.isFunction(this.options.error)
                    ? this.options.error(this.error)
                    : (0, lit_html_1.html) ` ${this.error} `}
          `
                : ''}
    `;
        },
    })
], Renderer);
//# sourceMappingURL=renderer.js.map